package com.tormec.sendkeyboardevent

import android.content.Context
import android.content.Intent
import io.flutter.embedding.engine.plugins.FlutterPlugin
import io.flutter.embedding.engine.plugins.FlutterPlugin.FlutterPluginBinding
import io.flutter.plugin.common.BinaryMessenger
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.MethodChannel.MethodCallHandler
import io.flutter.plugin.common.PluginRegistry.Registrar
import java.io.IOException

/** SendkeyboardeventPlugin */
public class SendkeyboardeventPlugin : FlutterPlugin, MethodCallHandler {

    private var applicationContext: Context? = null
    private var methodChannel: MethodChannel? = null

    override fun onAttachedToEngine(binding: FlutterPluginBinding) {
        onAttachedToEngine(binding.applicationContext, binding.binaryMessenger)
    }

    private fun onAttachedToEngine(applicationContext: Context, messenger: BinaryMessenger) {
        this.applicationContext = applicationContext
        methodChannel = MethodChannel(messenger, "sendkeyboardevent")
        methodChannel!!.setMethodCallHandler(this)
    }

    override fun onDetachedFromEngine(binding: FlutterPluginBinding) {
        applicationContext = null
        methodChannel!!.setMethodCallHandler(null)
        methodChannel = null
    }

    override fun onMethodCall(call: MethodCall, result: MethodChannel.Result) {
        if (call.method == "sendKeyboardEvent") {
            val keyCode = call.argument<Any>("keyCode") as Int
            val intent = Intent()
            intent.action = "ADB_INPUT_CODE"
            intent.putExtra("code", keyCode)
            applicationContext!!.sendBroadcast(intent)
            result.success("Event sent successfully")
            return
        }
        if (call.method == "sendKeyboardText") {
            val text = call.argument<String>("text")
            val intent = Intent()
            intent.action = "ADB_INPUT_TEXT"
            intent.putExtra("msg", text)
            applicationContext!!.sendBroadcast(intent)
            result.success("Event sent successfully")
            return
        }
        if (call.method == "sendADBCommand") {
            val command = call.argument<String>("command")
            try {
                Runtime.getRuntime().exec(command)
            } catch (e: IOException) {
                e.printStackTrace()
            }
            result.success("ADB command sent successfully")
            return
        }
        result.notImplemented()
    }

    companion object {
        @JvmStatic
        fun registerWith(registrar: Registrar) {
            val instance = SendkeyboardeventPlugin()
            instance.onAttachedToEngine(registrar.context(), registrar.messenger())
        }
    }
}