import 'package:flutter/services.dart';

class KeyCodes {
  static const int ENTER = 66;
  static const int BACKSPACE = 67;
}

class SendKeyboardEvent {
  static const MethodChannel _channel =
      const MethodChannel('sendkeyboardevent');

  static void sendKeyboardEvent(int keyCode) async {
    await _channel.invokeMethod('sendKeyboardEvent', <String, dynamic> {
      'keyCode': keyCode
    });
  }

  static void sendKeyboardText(String text) async {
    await _channel.invokeMethod('sendKeyboardText', <String, dynamic> {
      'text': text
    });
  }

  static void sendADBCommand(String command) async {
    await _channel.invokeMethod('sendADBCommand', <String, dynamic> {
      'command': command
    });
  }

}
